#pragma compile(Out, ColorBookEditor.exe)
#pragma compile(Icon, icon.ico)
#pragma compile(UPX, false)
#pragma compile(CompanyName, scintilla4evr)
#pragma compile(FileDescription, "Color Book Editor")
#pragma compile(FileVersion, 1.0.0.0)
#pragma compile(ProductName, "Color Book Editor")
#pragma compile(ProductVersion, 1.0.0.0)
#pragma compile(x64, false)

#include <GUIConstants.au3>
#include <WinAPIEx.au3>
#include <Misc.au3>
#include <ColorEx.au3>
#include <AutoItObject.au3>
#include <LinkedList.au3>
#include <GUIImageList.au3>
#include <GUIListView.au3>

_AutoItObject_Startup()

Global $oColorBook = _CreateColorBook("My Color Book")

$hGUI = GUICreate("Color Book Editor", 640, 535, -1, -1, $WS_OVERLAPPEDWINDOW)

$cidFileMenu = GUICtrlCreateMenu("File")
$cidNew = GUICtrlCreateMenuItem("New", $cidFileMenu)
$cidOpen = GUICtrlCreateMenuItem("Open", $cidFileMenu)
GUICtrlCreateMenuItem("", $cidFileMenu)
$cidSave = GUICtrlCreateMenuItem("Save as Color Book", $cidFileMenu)
$cidSaveACO = GUICtrlCreateMenuItem("Save as Color Swatches", $cidFileMenu)
GUICtrlCreateMenuItem("", $cidFileMenu)
$cidImportINI = GUICtrlCreateMenuItem("Import INI", $cidFileMenu)
GUICtrlCreateMenuItem("", $cidFileMenu)
$cidSaveAU3 = GUICtrlCreateMenuItem("Export as AutoIt constants", $cidFileMenu)
$cidSaveHTML = GUICtrlCreateMenuItem("Export as HTML file", $cidFileMenu)

GUICtrlCreateLabel("Color book title (click to change):", 10, 10, 200)
GUICtrlSetResizing(-1, $GUI_DOCKTOP+$GUI_DOCKLEFT+$GUI_DOCKSIZE)
$cidCBTitle = GUICtrlCreateLabel("My Color Book", 210, 10, 420)
GUICtrlSetResizing(-1, $GUI_DOCKTOP+$GUI_DOCKLEFT+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)
GUICtrlSetFont(-1, -1, 700)

$cidAddColor = GUICtrlCreateButton("Add color", 10, 30, 80, 25)
GUICtrlSetResizing(-1, $GUI_DOCKTOP+$GUI_DOCKLEFT+$GUI_DOCKSIZE)
$cidDelColor = GUICtrlCreateButton("Delete color", 100, 30, 80, 25)
GUICtrlSetResizing(-1, $GUI_DOCKTOP+$GUI_DOCKLEFT+$GUI_DOCKSIZE)
$cidEditColor = GUICtrlCreateButton("Edit color", 190, 30, 80, 25)
GUICtrlSetResizing(-1, $GUI_DOCKTOP+$GUI_DOCKLEFT+$GUI_DOCKSIZE)
$cidRenameColor = GUICtrlCreateButton("Rename color", 280, 30, 80, 25)
GUICtrlSetResizing(-1, $GUI_DOCKTOP+$GUI_DOCKLEFT+$GUI_DOCKSIZE)
$cidChangePrefix = GUICtrlCreateButton("Change prefix", 370, 30, 80, 25)
GUICtrlSetResizing(-1, $GUI_DOCKTOP+$GUI_DOCKLEFT+$GUI_DOCKSIZE)
$cidChangePostfix = GUICtrlCreateButton("Change postfix", 460, 30, 80, 25)
GUICtrlSetResizing(-1, $GUI_DOCKTOP+$GUI_DOCKLEFT+$GUI_DOCKSIZE)

$cidHelpMenu = GUICtrlCreateMenu("Help")
$cidAbout = GUICtrlCreateMenuItem("About...", $cidHelpMenu)

$cidColorList = GUICtrlCreateListView("", 10, 60, 620, 440)
GUICtrlSetResizing(-1, $GUI_DOCKBORDERS)

_GUICtrlListView_AddColumn($cidColorList, "Color Name")
_GUICtrlListView_AddColumn($cidColorList, "Hex")
_GUICtrlListView_SetView($cidColorList, 2)

$cidProgressBar = GUICtrlCreateProgress(10, 500, 620, 5)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT+$GUI_DOCKBOTTOM+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)

GUISetState()

$hIL = _GUIImageList_Create(24, 24)
_GUICtrlListView_SetImageList(GUICtrlGetHandle($cidColorList), $hIL, 1)

While 1
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE
			ExitLoop
		Case $cidCBTitle
			$sNewName = InputBox("Change color book name", "New color book name:", GUICtrlRead($cidCBTitle), "", -1, -1, Default, Default, 0, $hGUI)
			If Not @error Then
				GUICtrlSetData($cidCBTitle, $sNewName)
				$oColorBook.name = $sNewName
			EndIf
		Case $cidDelColor
			$iIdx = _GUICtrlListView_GetSelectedIndices(GUICtrlGetHandle($cidColorList))
			If $iIdx <> "" Then
				$oColorBook.colors.remove($iIdx)
				_GUICtrlListView_DeleteItem(GUICtrlGetHandle($cidColorList), $iIdx)
			EndIf
		Case $cidAddColor
			$iColor = _ChooseColor(2, 0, 0, $hGUI)
			If Not @error Then
				$sName = InputBox("Color name", "Color name:", "", "", -1, -1, Default, Default, 0, $hGUI)
				If Not @error Then
					$oColor = _CreateColor($sName, $iColor)
					$oColorBook.colors.add($oColor)

					$iIndex = _GUIImageList_Add($hIL, _GUICtrlListView_CreateSolidBitMap(GUICtrlGetHandle($cidColorList), $iColor, 24, 24))
					$iItem = _GUICtrlListView_AddItem($cidColorList, $oColorBook.prefix&$sName&$oColorBook.postfix, $iIndex)
					_GUICtrlListView_AddSubItem($cidColorList, $iItem, "#"&Hex($iColor, 6), 1)
				EndIf
			EndIf
		Case $cidRenameColor
			$iIdx = _GUICtrlListView_GetSelectedIndices(GUICtrlGetHandle($cidColorList))
			If $iIdx <> "" Then
				$oColor = $oColorBook.colors.at($iIdx)
				$sNewName = InputBox("Change color name", "New color name:", $oColor.name, "", -1, -1, Default, Default, 0, $hGUI)
				If Not @error Then
					$oColor.name = $sNewName
					_GUICtrlListView_SetItemText($cidColorList, $iIdx, $oColorBook.prefix&$sNewName&$oColorBook.postfix)
				EndIf
			EndIf
		Case $cidEditColor
			$iIdx = _GUICtrlListView_GetSelectedIndices(GUICtrlGetHandle($cidColorList))
			If $iIdx <> "" Then
				$oColor = $oColorBook.colors.at($iIdx)
				$iColor = _ChooseColor(2, $oColor.hex, 2, $hGUI)
				If Not @error Then
					$oColor.hex = $iColor
					$iIndex = _GUIImageList_Add($hIL, _GUICtrlListView_CreateSolidBitMap(GUICtrlGetHandle($cidColorList), $iColor, 24, 24))
					_GUICtrlListView_SetItemImage($cidColorList, $iIdx, $iIndex)
				EndIf
			EndIf
		Case $cidNew
			$oColorBook = _CreateColorBook("My Color Book")
			GUICtrlSetData($cidCBTitle, "My Color Book")
			_GUICtrlListView_DeleteAllItems($cidColorList)
		Case $cidOpen
			$sFile = FileOpenDialog("", "", "Color Books (*.ACB)", 0, "", $hGUI)
			If Not @error Then _OpenColorBook($sFile)
		Case $cidSave
			$sFile = FileSaveDialog("", "", "Color Books (*.ACB)", 0, "", $hGUI)
			If Not @error Then _SaveColorBook($sFile)
		Case $cidSaveACO
			$sFile = FileSaveDialog("", "", "Color Swatches (*.ACO)", 0, "", $hGUI)
			If Not @error Then _SaveColorSwatch($sFile)
		Case $cidImportINI
			$sFile = FileOpenDialog("", "", "INI files (*.INI)", 0, "", $hGUI)
			If Not @error Then _ImportINI($sFile)
		Case $cidSaveAU3
			$sFile = FileSaveDialog("", "", "AutoIt scripts (*.AU3)", 0, "", $hGUI)
			If Not @error Then _SaveAutoIt($sFile)
		Case $cidSaveHTML
			$sFile = FileSaveDialog("", "", "HTML webpages (*HTML)", 0, "", $hGUI)
			If Not @error Then _SaveHTML($sFile)
		Case $cidChangePrefix
			$sNewName = InputBox("Change color book prefix", "New color book prefix:", $oColorBook.prefix, "", -1, -1, Default, Default, 0, $hGUI)
			If Not @error Then
				$iRemove = MsgBox($MB_YESNO+$MB_ICONQUESTION, "Prefix change", "Do you want to remove the prefix from color names that already contain it?", 0, $hGUI)
				If $iRemove = 6 Then
					For $color In $oColorBook.colors
						If StringLeft($color.name, StringLen($sNewName)) = $sNewName Then $color.name = StringTrimLeft($color.name, StringLen($sNewName))
					Next
				EndIf
				$oColorBook.prefix = $sNewName
				_RefreshColorList()
			EndIf
		Case $cidChangePostfix
			$sNewName = InputBox("Change color book postfix", "New color book postfix:", $oColorBook.postfix, "", -1, -1, Default, Default, 0, $hGUI)
			If Not @error Then
				$iRemove = MsgBox($MB_YESNO+$MB_ICONQUESTION, "Postfix change", "Do you want to remove the postfix from color names that already contain it?", 0, $hGUI)
				If $iRemove = 6 Then
					For $color In $oColorBook.colors
						If StringRight($color.name, StringLen($sNewName)) = $sNewName Then $color.name = StringTrimRight($color.name, StringLen($sNewName))
					Next
				EndIf
				$oColorBook.postfix = $sNewName
				_RefreshColorList()
			EndIf
		Case $cidAbout
			MsgBox($MB_ICONINFORMATION, "About Color Book Editor", "Version 1.0"&@crlf&"by scintilla4evr")
	EndSwitch
WEnd

_AutoItObject_Shutdown()
_GUIImageList_Destroy($hIL)

Func _ImportINI($sFile)
	$aColors = IniReadSection($sFile, "Colors")

	For $i = 1 To $aColors[0][0]
		$oColor = _CreateColor($aColors[$i][0], Dec($aColors[$i][1]))
		$oColorBook.colors.add($oColor)
	Next

	_RefreshColorList()
EndFunc

Func _RefreshColorList()
	_GUICtrlListView_DeleteAllItems($cidColorList)

	For $color In $oColorBook.colors
		$iIndex = _GUIImageList_Add($hIL, _GUICtrlListView_CreateSolidBitMap(GUICtrlGetHandle($cidColorList), $color.hex, 24, 24))
		$iItem = _GUICtrlListView_AddItem($cidColorList, $oColorBook.prefix&$color.name&$oColorBook.postfix, $iIndex)
		_GUICtrlListView_AddSubItem($cidColorList, $iItem, "#"&Hex($color.hex, 6), 1)
	Next
EndFunc

Func _CreateColorBook($sName, $sPrefix = "", $sPostfix = "")
	Local $oCB = _AutoItObject_Create()

	_AutoItObject_AddProperty($oCB, "name", Default, $sName)
	_AutoItObject_AddProperty($oCB, "prefix", Default, $sPrefix)
	_AutoItObject_AddProperty($oCB, "postfix", Default, $sPostfix)

	_AutoItObject_AddProperty($oCB, "colors", Default, LinkedList())

	Return $oCB
EndFunc

Func _CreateColor($sName, $iRGB)
	Local $oColor = _AutoItObject_Create()

	_AutoItObject_AddProperty($oColor, "name", Default, $sName)
	_AutoItObject_AddProperty($oColor, "hex", Default, $iRGB)

	Return $oColor
EndFunc

Func _SaveColorBook($sFile)
	$nBytes = 0
	$hFile = _WinAPI_CreateFile($sFile, 1, 4)

	$tHeader = DllStructCreate("align 2; char header[4]; short version; short id")
	$tHeader.header = "8BCB"
	$tHeader.version = _WinAPI_SwapWord(1)
	$tHeader.id = _WinAPI_SwapWord(3999)
	_WinAPI_WriteFile($hFile, $tHeader, DllStructGetSize($tHeader), $nBytes)

	_WriteVariableLengthString($hFile, $oColorBook.name)
	_WriteVariableLengthString($hFile, $oColorBook.prefix)
	_WriteVariableLengthString($hFile, $oColorBook.postfix)
	_WriteVariableLengthString($hFile, "")

	$tInfo = DllStructCreate("align 2; short numColors; short colorsPerPage; short keyColorPage; short type")
	$tInfo.numColors = _WinAPI_SwapWord($oColorBook.colors.count)
	$tInfo.colorsPerPage = _WinAPI_SwapWord(5)
	$tInfo.keyColorPage = _WinAPI_SwapWord(5)
	$tInfo.type = 0

	_WinAPI_WriteFile($hFile, $tInfo, DllStructGetSize($tInfo), $nBytes)

	$id = 0
	For $color In $oColorBook.colors
		_WriteVariableLengthString($hFile, $color.name)

		$tColor = DllStructCreate("align 2; char key[6]; byte color[3]")
		$key = String($id)
		If StringLen($key) < 6 Then
			Do
				$key = " "&$key
			Until StringLen($key) = 6
		EndIf
		$tColor.key = $key

		$aColor = _ColorGetRGB($color.hex)
		$tColor.color(1) = $aColor[0]
		$tColor.color(2) = $aColor[1]
		$tColor.color(3) = $aColor[2]
		_WinAPI_WriteFile($hFile, $tColor, DllStructGetSize($tColor), $nBytes)

		$id += 1
	Next

	_WinAPI_CloseHandle($hFile)
EndFunc

Func _SaveColorSwatch($sFile)
	$nBytes = 0
	$hFile = _WinAPI_CreateFile($sFile, 1, 4)

	$tHeader = DllStructCreate("align 2; short version; short count")
	$tHeader.version = _WinAPI_SwapWord(2) ; who cares about ver 1?
	$tHeader.count = _WinAPI_SwapWord($oColorBook.colors.count)
	_WinAPI_WriteFile($hFile, $tHeader, DllStructGetSize($tHeader), $nBytes)

	For $color In $oColorBook.colors
		$tColor = DllStructCreate("align 2; short space; ushort color[4]")
		$tColor.space = 0

		$aColor = _ColorGetRGB($color.hex)
		$tColor.color(1) = _WinAPI_SwapWord($aColor[0]*256)
		$tColor.color(2) = _WinAPI_SwapWord($aColor[1]*256)
		$tColor.color(3) = _WinAPI_SwapWord($aColor[2]*256)
		_WinAPI_WriteFile($hFile, $tColor, DllStructGetSize($tColor), $nBytes)

		_WriteVariableLengthString($hFile, $oColorBook.prefix&$color.name&$oColorBook.postfix, 1)
	Next

	_WinAPI_CloseHandle($hFile)
EndFunc

Func _SaveAutoIt($sFile)
	$hFile = FileOpen($sFile, 2)

	FileWrite($hFile, "#include-once"&@CRLF)
	FileWrite($hFile, "; Exported from Adobe Color Book Editor"&@CRLF)
	FileWrite($hFile, ";  Color Book: "&$oColorBook.name&@CRLF&@CRLF)

	For $color In $oColorBook.colors
		$sName = "$"&StringUpper(StringReplace(StringReplace($oColorBook.prefix&$color.name&$oColorBook.postfix, " ", "_"), "-", "_"))
		FileWrite($hFile, "Global Const "&$sName&" = 0x"&Hex($color.hex, 6)&@CRLF)
	Next

	FileClose($hFile)
EndFunc

Func _SaveHTML($sFile)
	$hFile = FileOpen($sFile, 2)
	$sHTMLData = FileRead(@ScriptDir&"\template.html")

	$sHTMLData = StringReplace($sHTMLData, "$$ACBNAME$$", $oColorBook.name)
	$sHTMLData = StringReplace($sHTMLData, "$$ACBCOUNT$$", $oColorBook.colors.count)

	$sColorEntries = ""

	For $color In $oColorBook.colors
		$sName = $oColorBook.prefix&$color.name&$oColorBook.postfix
		$aRGB = _ColorGetRGB($color.hex)
		$aCMYK = _ColorConvertRGBToCMYK($aRGB)
		$aLab = _ColorConvertXYZToCIELab(_ColorConvertRGBToXYZ($aRGB))
		$sColorEntries &= @tab&@tab&@tab&'<tr><td class="colorCell" style="background: #'&Hex($color.hex, 6)&'"></td><td class="colorInfo"><h2>'&$sName&'</h2>Hex: #'&Hex($color.hex, 6)&'; RGB: '&StringFormat("%d, %d, %d", $aRGB[0], $aRGB[1], $aRGB[2])&'; CMYK: '&StringFormat("%d, %d, %d, %d", $aCMYK[0], $aCMYK[1], $aCMYK[2], $aCMYK[3])&'; Lab: '&StringFormat("%.1f, %.1f, %.1f", $aLab[0], $aLab[1], $aLab[2])&'</td></tr>'&@CRLF
	Next
	$sHTMLData = StringReplace($sHTMLData, "$$ACBENTRIES$$", $sColorEntries)

	FileWrite($hFile, $sHTMLData)
	FileClose($hFile)
EndFunc

Func _OpenColorBook($sFile)
	$oCB = _CreateColorBook("")
	$nBytes = 0

	$hFile = _WinAPI_CreateFile($sFile, 2, 2)

	$tStruct = DllStructCreate("align 2; char header[4]; short version; short id")
	$tDummy = DllStructCreate("byte[128]")
	_WinAPI_ReadFile($hFile, $tStruct, DllStructGetSize($tStruct), $nBytes)

	$sTitle = _StripI18nString(_GetVariableLengthString($hFile))
	GUICtrlSetData($cidCBTitle, $sTitle)
	$oCB.name = $sTitle

	$sPrefix = _StripI18nString(_GetVariableLengthString($hFile))
	$oCB.prefix = $sPrefix

	$sPostfix = _StripI18nString(_GetVariableLengthString($hFile))
	$oCB.postfix = $sPostfix

	$sDesc = _StripI18nString(_GetVariableLengthString($hFile))

	$tInfo = DllStructCreate("short numColors; short colorsPerPage; short keyColorPage; short type")
	_WinAPI_ReadFile($hFile, $tInfo, DllStructGetSize($tInfo), $nBytes)

	For $c = 1 To _WinAPI_SwapWord($tInfo.numColors)
		$sName = _GetVariableLengthString($hFile)
		$tData = DllStructCreate("char id[6]; byte color["&(((_WinAPI_SwapWord($tInfo.type)) = 2) ? 4 : 3)&"];")
		_WinAPI_ReadFile($hFile, $tData, DllStructGetSize($tData), $nBytes)

		If StringLen($sName) > 0 Then
			$sName = _StripI18nString($sName)

			$sColor = ""
			Local $aColor[3]
			Switch _WinAPI_SwapWord($tInfo.type)
				Case 0
					$aColor[0] = $tData.color(1)
					$aColor[1] = $tData.color(2)
					$aColor[2] = $tData.color(3)
				Case 7
					$aColor[0] = $tData.color(1)/2.55
					$aColor[1] = $tData.color(2)-128
					$aColor[2] = $tData.color(3)-128
					$aColor = _ColorConvertXYZToRGB(_ColorConvertCIELabToXYZ($aColor))
				Case 2
					Local $aCMYK = [100-$tData.color(1)/2.55, 100-$tData.color(2)/2.55, 100-$tData.color(3)/2.55, 100-$tData.color(4)/2.55]
					$aColor = _ColorConvertCMYKToRGB($aCMYK)
			EndSwitch
			$iColor = _ColorSetRGB($aColor)

			$oCB.colors.add(_CreateColor($sName, $iColor))
		EndIf
		GUICtrlSetData($cidProgressBar, ($c/_WinAPI_SwapWord($tInfo.numColors))*100)
	Next

	_WinAPI_CloseHandle($hFile)

	$oColorBook = $oCB
	_RefreshColorList()
EndFunc

Func _GetVariableLengthString($hFile)
	$nBytes = 0

	$tSize = DllStructCreate("ulong len")
	_WinAPI_ReadFile($hFile, $tSize, DllStructGetSize($tSize), $nBytes)

	$sStr = ""
	For $i = 1 To _WinAPI_SwapDWord($tSize.len)
		$tChar = DllStructCreate("ushort chr")
		_WinAPI_ReadFile($hFile, $tChar, DllStructGetSize($tChar), $nBytes)
		$sStr &= ChrW(_WinAPI_SwapWord($tChar.chr))
	Next

	Return $sStr
EndFunc

Func _WriteVariableLengthString($hFile, $sStr, $iBias = 0)
	$nBytes = 0

	$tSize = DllStructCreate("ulong len")
	$tSize.len = _WinAPI_SwapDWord(StringLen($sStr)+$iBias)
	_WinAPI_WriteFile($hFile, $tSize, DllStructGetSize($tSize), $nBytes)

	For $i = 1 To StringLen($sStr)
		$tChar = DllStructCreate("ushort chr")
		$tChar.chr = _WinAPI_SwapWord(AscW(StringMid($sStr, $i, 1)))
		_WinAPI_WriteFile($hFile, $tChar, DllStructGetSize($tChar), $nBytes)
	Next

	If $iBias > 0 Then
		For $i = 1 To $iBias
			$tChar = DllStructCreate("ushort chr")
			$tChar.chr = 0
			_WinAPI_WriteFile($hFile, $tChar, DllStructGetSize($tChar), $nBytes)
		Next
	EndIf
EndFunc

Func _StripI18nString($sStr)
	If StringRegExp($sStr, "\$\$\$.*=(.*)", $sStr) Then
		$aRexp = StringRegExp($sStr, "\$\$\$.*=(.*)", 1)
		If IsArray($aRexp) Then
			$sStr = $aRexp[0]
		EndIf
	EndIf

	$sStr = StringReplace($sStr, "^C", "")
	$sStr = StringReplace($sStr, "^R", "")

	Return $sStr
EndFunc
